program Set_04;
{
     
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

type

  TCharSet = set of 'a'..'z';

  TSetTest = class(TSetList)
     procedure GetData(var arg : TCharSet);
  end;

{ TSetTest }

procedure TSetTest.GetData(var arg: TCharSet);
var t : TItemChar;
    c : Char;
begin
  arg:=[];
  t:= TItemChar(GetFirst);
  while Assigned(t) do begin
    c:= TItemChar(t).GetData;
    arg:= arg + [c];
    t:= TItemChar(GetNext);
  end;
end;

//////////////////////////////////////////////////////

procedure Generate (var arg: TCharSet);
var n : integer;
    c : char;
begin
  arg:=[];
  n:= Random(Ord('z')-Ord('a')+1);
  while n>0 do begin
    c:= Char(Ord('a') + Random(Ord('z')-Ord('a')+1));
    if not (c in arg) then begin
      arg:= arg + [c];
      Dec(n);
    end;
  end;
end;

//////////////////////////////////////////////////////

var S1, S2, S3 : TSetTest;
    x1, x2 : TCharSet;
    N: integer;
    F: Text;

procedure SetsLoad;
var x : TCharSet;
    c : char;
    t : TItemChar;
begin
  x1:=[]; x2:= [];
  S1.Clear;
  S2.Clear;
  S3.Clear;
  Generate(x);
  for c in x do begin
    t:= TItemChar.Create(c);
    S3.Insert(t);
    if Random(4)<3  then begin
      S1.Insert(t);
      x1:= x1+[c];
    end;
    if Random(4)<2  then begin
      S2.Insert(t);
      x2:= x2+[c];
    end;
  end;
end;

function TestAdd: boolean;
var a, b : TCharSet;
begin
  SetsLoad;
  a:= x1+x2;
  S1.Add(S2);
  S1.GetData(b);
  Result:= a=b;
  if not Result then begin
    Writeln(F,'TestAdd:');
    S2.Expo;
    S1.Expo;
  end;
end;

function TestSub: boolean;
var a, b : TCharSet;
begin
  SetsLoad;
  a:= x1-x2;
  S1.Sub(S2);
  S1.GetData(b);
  Result:= a=b;
  if not Result then begin
    Writeln(F,'TestSub:');
    S2.Expo;
    S1.Expo;
  end;
end;

function TestMul: boolean;
var a, b : TCharSet;
begin
  SetsLoad;
  a:= x1*x2;
  S1.Mul(S2);
  S1.GetData(b);
  Result:= a=b;
  if not Result then begin
    Writeln(F,'TestMul:');
    S2.Expo;
    S1.Expo;
  end;
end;

function TestExOr: boolean;
var a, b : TCharSet;
begin
  SetsLoad;
  a:= x1+x2 - x1*x2;
  S1.ExOr(S2);
  S1.GetData(b);
  Result:= a=b;
  if not Result then begin
    Writeln(F,'TestExOr:');
    S2.Expo;
    S1.Expo;
  end;
end;



begin
  Assign(F,'Test.txt'); Rewrite(F);
  Randomize;
  S1:= TSetTest.Create;
  S2:= TSetTest.Create;
  S3:= TSetTest.Create;
  N:=0;
  repeat
    Inc(N);
    Writeln('N= ', N);
    if not TestAdd then Break;;
    if not TestSub then Break;;
    if not TestMul then Break;;
    if not TestExOr then Break;;
  until N>1000;
  Close(F);
  Readln;
end.
