program Set_05;
{
     "" (  )
   :
 1)     (+)
 2)  ,   (-)
 3)     (*)
 4) XOR
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

type

  TSetOfWords = class(TSetList)
    procedure LoadFromText(aName : string);
    procedure Print(var aFile: Text); override;
  end;

////////////////////////////////////////////////////////////////

{ TSetOfWords }

procedure TSetOfWords.Print(var aFile: Text);
var p : TItem;
    N : integer;
begin
  Writeln(aFile, 'Cnt= ', mCount);
  N:=0;
  p:= GetFirst;
  while Assigned(p) do begin
    Inc(N);
    Write(aFile,N:4,'  ');
    p.Print(aFile);
    p:= GetNext;
  end;
  Writeln(aFile);
end;

procedure TSetOfWords.LoadFromText(aName: string);
const CHRS1 = ['A'..'Z','_'];
      CHRS2 = ['A'..'Z', '0'..'9','_'];
      
var F: Text;
    c : char;
    S: string;
    t: TItemStr;

begin
  Clear;
  Assign(F, aName); Reset(F);
  while not Eof(F) do begin
    c:=#32; S:='';
    while not Eof(F) and not (c in CHRS1) do begin
      Read(F, c);
      c:= Upcase(c);
    end;
    while not Eof(F) and (c in CHRS2) do begin
      S:= S+c;
      Read(F, c);
      c:= Upcase(c);
    end;
    if Length(S)>0 then begin
      t:= TItemStr.Create(S);
      if not Insert(t)
        then t.Free;
    end;   
  end;
  Close(F);
end;

////////////////////////////////////////////////////////////////

procedure Main;
var Set1, Set2: TSetOfWords;
    S : TSetOfWords;

begin
  Set1:= TSetOfWords.Create;
  Set1.LoadFromText('..\Common\Root.pas');
  Set1.Expo;

  Set2:= TSetOfWords.Create;
  Set2.LoadFromText('..\Common\Items.pas');
  Set2.Expo;

  S:= TSetOfWords.Create;

  Writeln(Output, '--- Set1 + Set2 ---'#10);
  S.CopyItems(Set1);
  S.Add(Set2);
  S.Expo;

  Writeln(Output, '--- Set1 - Set2 ---'#10);
  S.CopyItems(Set1);
  S.Sub(Set2);
  S.Expo;

  Writeln(Output, '--- Set1 * Set2 ---'#10);
  S.CopyItems(Set1);
  S.Mul(Set2);
  S.Expo;

  Writeln(Output, '--- Set1 xor Set2 ---'#10);
  S.CopyItems(Set1);
  S.ExOr(Set2);
  S.Expo;

  Set1.ClrAndDestroy;
  Set2.ClrAndDestroy;

  S.Free;
  Set2.Free;
  Set1.Free;
end;

////////////////////////////////////////////////////////////////

begin
  try
    Main;
    Assign(Output,'Out.txt'); Rewrite(Output);
    Main;
    Close(Output);
    Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
