program Compare;
{
       
  TGraph.GenPairs_Edmonds
         
  TGraph.GenPairs_Dissect
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';


var Nodes: integer;     //   
    Density: integer;   //  , %
    Retry: integer;     //   ()
    i: integer;         //  

    Graph: TGraph;      //  
    Pairs: TCostSet;    //  
    Error: boolean;     //  

    Cost_Dissect: integer;  //    
    Cost_Edmonds: integer;  //   
    Mode: TPairs; {integer;}//  


begin
  try
    repeat
      Writeln;
      //     (+, -)
      Write('Nodes     (>4) = '); Readln(Nodes);
      if Abs(Nodes)<5 then Break;
      //   , %
      Write('Density,% (>0) = '); Readln(Density);
      if Abs(Density)<1 then Break;
      //   
      Write('Retry     (>0) = '); Readln(Retry);
      if Retry<=0 then Break;
      //    
      for i := 1 to Retry do begin
        Write('.');
        //   
        Graph:= TGraphChars.GenRandom(
                false,  //  
                1,      //  
                99,     //  ,   = 99
                Nodes,  //  ,  
                Density //  , %  
                );
        // - - - - - - - - - - - - - - - - - - - - -
        //     
        Mode:= pMaxN;
        Pairs:= Graph.GenPairs_Edmonds(Mode);
        Cost_Edmonds:= Pairs.mCost;
        Pairs.Free;
        Pairs:= Graph.GenPairs_Dissect(Mode);
        Cost_Dissect:= Pairs.mCost;
        Pairs.Free;
        Error:= Cost_Edmonds <> Cost_Dissect;
        if Error then Break;
        // - - - - - - - - - - - - - - - - - - - - -
        //     
        Mode:= pMaxW;
        Pairs:= Graph.GenPairs_Edmonds(Mode);
        Cost_Edmonds:= Pairs.mCost;
        Pairs.Free;
        Pairs:= Graph.GenPairs_Dissect(Mode);
        Cost_Dissect:= Pairs.mCost;
        Pairs.Free;
        Error:= Cost_Edmonds <> Cost_Dissect;
        if Error then Break;
        // - - - - - - - - - - - - - - - - - - - - -
        //     
        Mode:= pMinW;
        Pairs:= Graph.GenPairs_Edmonds(Mode);
        Cost_Edmonds:= Pairs.mCost;
        Pairs.Free;
        Pairs:= Graph.GenPairs_Dissect(Mode);
        Cost_Dissect:= Pairs.mCost;
        Pairs.Free;
        Error:= Cost_Edmonds <> Cost_Dissect;
        if Error then Break;

        Graph.Free;
      end;
    until Error;
    if Error then begin
      Graph.Save('Graph.txt');
      Write('### Error! Press Enter...');
      Readln;
    end else begin
      Writeln('OK!');
    end;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
