program Edmonds_Time;
{
       
    TGraph.GenPairs_Edmonds
}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Math,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';


const CMode = pMaxW;  //    

var
  Nodes: integer;     //   
  Density: integer;   //  , %
  Retry: integer;     //   ()
  Time_Edmons : Extended; //    GenPairs_Edmonds
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//     ( )

procedure ResultExpo(const aFile: String);
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln;
  Writeln('---------------------------------------------------');
  Writeln('Nodes=', Nodes:4, ' Retry=', Retry:4, ' Dens=', Density,' %');
  Writeln('Edmons = ', Time_Edmons/Retry:7:3,' ms');
  Writeln('---------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

var
  Graph: TGraph;      //  
  Pairs: TCostSet;    //  
  Start: TDateTime;   //  
  Time : integer;     //  
  Pack : integer;     //    GenPairs_Edmonds
  k, i: integer;      // 

begin
  try
  repeat
    //     (+, -)
    Write('Nodes     (>4) = '); Readln(Nodes);
    if Abs(Nodes)<5 then Break;
    //   , %
    Write('Density,% (>0) = '); Readln(Density);
    if Abs(Density)<1 then Break;
    //   
    Write('Retry     (>0) = '); Readln(Retry);
    if Retry<=0 then Break;
    
    //      
    Pack:= 1+(100000 div abs(Nodes)) div abs(Density);

    Time_Edmons:= 0;
    for i:= 1 to Retry do begin
      Write('.');
      //   
      Graph:= TGraphChars.GenRandom(
              false,  //  
              1,      //  
              99,     //  ,   = 99
              Nodes,  //  ,  
              Density //  , %  
              );
      //   GenPairs_Edmonds
      Start:= Now; //   
      //   
      for k:=1 to Pack do begin
        Pairs:= Graph.GenPairs_Edmonds(CMode);
        Pairs.Free; //  
      end;
      //   
      Time:= MilliSecondsBetween(Start, Now);
      //    GenPairs_Edmonds
      Time_Edmons:= Time_Edmons + Time/Pack;

      Graph.Free;  //  
    end;  // for  i:= 1 to Retry
    ResultExpo('');
    ResultExpo('#Edmonds_Time.txt');
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

