program Graph_32b;

{$APPTYPE CONSOLE}
{
        
    
}
uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

const CPc = 2;      //    %
      CArray = 20;  // 2*20 = 40 %

var Gr  : TGraph;
    Res : TBuffer;
    Cost: integer;
    i,k : integer;

    Start : TDateTime;
    Time  : integer;

    Nodes : integer;  //  
    Retry : integer;  //  

    //  (%):
    CF : integer;   //   (100%)
    CQ : extended;  // 
    CG : extended;  // 
    CR : extended;  // 

    // :
    TF : integer; //  
    TQ : integer; // 
    TG : integer; // 
    TR : integer; // 

    Arr : array [1..CArray] of integer;

//    

function HamToStr(aBuf: TBuffer): string;
var N: TNode;
    i: integer;
begin
  Result:='';
  for i:= 1 to aBuf.GetCount do begin
    N:= aBuf.Get as TNode;
    aBuf.Put(N);
    Result:= Result+ N.GetName;
    if i<aBuf.GetCount then Result:=Result +'-';
  end;
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 //  
procedure ResultExpo(const aFile: String);
var n: integer;
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln('-----------------------------------------------------------');
  Writeln('  Nodes=', Nodes:4, '  Retry=', Retry:4);
  Writeln('           %       ms');
  Writeln('Main =   100.0',           TF/Retry:7:0);
  Writeln('Quick= ',100*CQ/Retry:7:1, TQ/Retry:7:0);
  Writeln('Greed= ',100*CG/Retry:7:1, TG/Retry:7:0);
  Writeln('Rand = ',100*CR/Retry:7:1, TR/Retry:7:0);
  for n:= 1 to CArray do Writeln(n*CPc:3,#9, Arr[n]);;
  Writeln('-----------------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


begin
  try
  repeat
    Write('Nodes= '); Readln(Nodes);
    if Nodes<5 then Break;
    repeat
      Write('Retry= '); Readln(Retry);
      if Retry=0 then Break;
      //    
      CQ:=0; CG:=0; CR:=0;
      TF:=0; TQ:=0; TG:=0; TR:=0;
      //  
      for k:= 1 to CArray do Arr[k]:=0;

      for i:= 1 to Retry do begin
        Write('.');
        Gr:= TGraphChars.GenFull(false, 0, 99, Nodes);
        //-------------------------------------------
        //  
        Start:= Now;
        Res:= Gr.GenHamilton(Cost);
        Time:= MilliSecondsBetween(Start, Now);
        Res.Free;
        CF:= Cost; Inc(TF, Time);
        //-------------------------------------------
        //  
        Start:= Now;
        Res:= Gr.GenHamilton_Quick(Cost);
        Time:= MilliSecondsBetween(Start, Now);
        Res.Free;
        CQ:= CQ + Cost/CF; Inc(TQ, Time);
        // k -    
        k:= 1 + Round(100*(Cost/CF-1)/CPc);
        if k in [1..CArray] then Inc(Arr[k]);

        //-------------------------------------------
        // 
        Start:= Now;
        Res:= Gr.GenHamilton_Greed(Cost, true);
        Time:= MilliSecondsBetween(Start, Now);
        Res.Free;
        CG:= CG + Cost/CF; Inc(TG, Time);
        //-------------------------------------------
        // 
        Start:= Now;
        Res:= Gr.GenHamilton_Greed(Cost, false);
        Time:= MilliSecondsBetween(Start, Now);
        Res.Free;
        CR:= CR + Cost/CF; Inc(TR, Time);
        //-------------------------------------------
        Gr.Free;
      end;
      Writeln;
      ResultExpo('');
      ResultExpo('Test_Time.txt');
    until false;
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
